#!/usr/local/bin/perl/ 

# working.pl
use Tk;

if (scalar(@ARGV) > 1) {
  die ("USAGE: working.pl <filename>\n");
}

#system ("setenv HMMVIEW /nfs/wol2/people/robin/hmmview/perl/");

# This is the driver perl function which is used to start up the
# HMMER Viewer.  This is for version 1.0, a complete rewrite of
# the initial 0.* series.

# Necessary "global" variables
$path = $ENV{'HMMVIEW'};	#Initial directory in which to look
$courier = "-adobe-courier-medium-r-normal--14-100-100-100-m-90-iso8859-1";
$courier2 = "-adobe-courier-medium-r-normal--11-80-100-100-m-60-iso8859-1";
$courier3 = "-adobe-courier-medium-r-normal--8-80-75-75-m-50-iso8859-1";
$courierbold = "-adobe-courier-bold-o-normal--14-100-100-100-m-90-iso8859-1";

$nodes = 5;		# Number of nodes visible in x direction
			# Needs to be an odd number (consensus clicks)
$interval = 140;	# Window scaling factor
$filename = "";

require("hmmparse.pl");

# Boolean Variables
$show_i_hist = 0;
$show_m_hist = 1;
$fromconsensus = 0;
$hist_visible = 0;	
$use_probs = 0;		
$in_p7 = 0;
$loaded = 0;
$center_value = 3;

# Model dependent factors.
$model_name = ""; # Name of current model
$leng = 10;	  # Size in nodes of current model
$alpha = 20;      # Size of the alphabet


# HMMER algorithm dependent default behaviors.
# Eventually plan to have a flag in HMMER file format for
# specifying which algorithm used.
#  E->J > 0 -> ls or fs
#  B->M2 > 0 -> sw or fs
# Variables for algorithm dependent aspects of the model
$bm = 0;	# Boolean for E->J > 0
$ej = 0;	# Boolean for B->M2 > 0


# Histogram View printing constants
$digits = 4;
$cutoff = .000001;
$curr_select = 0;

&set_scaling();

# Scaling 
sub set_scaling {
  $node_width = (4*$interval)/$nodes; # Width per node @current zoom 
  $width = int(0.25*$node_width);   # Width of a State Symbol
  $match_y = 1.0*$interval - 0.5*$width;	# Y location of Match 
  $insert_y = 1.5*$interval - 0.5*$width;  # Y location of Insert
  $delete_y = 0.35*$interval - 0.5*$width;  # Y location of Delete
  $max_line = $width/8;
  $diamond_s = sqrt(0.5*($width**2));
  $ldiamond_s = 2*$diamond_s;

  # Node at center of screen .. $nodes is always odd so must add 1
  $center_value = int($nodes/2) + 1;	  
  $start_value = $center_value - int($nodes/2);
}

$p7width = $width;

# Color choices
$match_color = 'dodgerblue';
$insert_color = 'red';
$delete_color = 'yellow';
$plan7_color = 'green';
$transition_color = 'grey';
$highlight_color = 'orange';
$sigcolor = 'black';

require("mw.pl");
require("consensus.pl");
require("mmodel.pl");
require("plan7.pl");
require("hist.pl");
require("menu.pl");

$nodes = 9;

if (scalar(@ARGV) > 0) {
  $filename = $ARGV[0];
  &load_hmmfile;
}

MainLoop();


