# mmodel.pl
# Subroutines to control placement of main model 
# Currently they do not handle the B and E nodes at edges of model

# Subroutine to redraw nodes of model.  
# These only change on zooming.

sub build_mmodel_v {

$mmodel_v->delete("all");

for ($j = 0, $z = $start_value, $t = 1; 
	$t < ($nodes + 1); 
	$j = $j + $node_width, $z++, $t++) {

 # Boundries
 $match_x = $j;
 $insert_x = $j + $node_width/2;
 $delete_x = $j + $node_width/15;

 # Match State
 if ($nodes < 11) {
   $mmodel_v->createRectangle($match_x,$match_y,
        $match_x + $width, $match_y + $width,
        -outline => $match_color,
        -tags => [$z, 'state_v'],
        -fill => $match_color);
 }
 # Insert State
 if ($z < $leng) {  # Last node has no insert state
   $mmodel_v->createPolygon($insert_x, $insert_y,
        $insert_x - $diamond_s, $insert_y + $diamond_s,
        $insert_x, $insert_y + $ldiamond_s,
        $insert_x + $diamond_s, $insert_y + $diamond_s,
        -outline => $insert_color,
        -fill => $insert_color,
        -tags => [$z, 'state_v'],
        -width => 2);
 }
 # Delete State
 $mmodel_v->createOval($delete_x, $delete_y,
        $delete_x + $width, $delete_y + $width,
        -outline => $delete_color,
        -width => 2,
        -tags => [$z, 'state_v'],
        -fill => $delete_color);
 $mmodel_v->update();	# Flush Buffer
} # End for loop

 \&build_trans();  # Add variable data information

 $mmodel_v->Tk::bind("<Button-1>", [\&see_hist, Ev('x')]);

} # End build_mmodel_v

# Subroutine to draw data portion of model.
# Changes on zooms, scrolls, etc.
sub build_trans {

$mmodel_v->delete("data");

for ($j = 0, $z = $start_value, $t = 1; 
	$t < ($nodes + 1); 
	$j = $j + $node_width, $z++, $t++) {

 # Boundries
 $match_x = $j;
 $insert_x = $j + $node_width/2;
 $delete_x = $j + $node_width/15;
 
 # State Label (number)
 $mmodel_v->createText($j + $node_width/2, 10, 
	-tags => ['data'],
	-text => $z);

 # Alpha labels for match states
 if ($nodes < 11) {
   $mmodel_v->createText($match_x + 0.5*$width, $match_y + 0.5*$width,
        -text => $E_alpha_char[$maxchar_m[$z]],
        -fill => 'white',
        -tags => [$z, 'state_v', 'data'],
        -anchor => 'center');
 } else {
   $mmodel_v->createText($match_x + 0.5*$width, $match_y + 0.5*$width,
        -text => $E_alpha_char[$maxchar_m[$z]],
        -fill => $match_color, 
        -tags => [$z, 'state_v', 'data'],
        -anchor => 'center');
 }
 # Transitions:
 # Match -> Delete
  &draw_trans($transition[$z][2], $match_x + $width, $match_y + 0.5*$width, 
        $delete_x + $node_width + 0.5*$width, $delete_y + $width, $z);
 # Match -> Insert
  &draw_trans($transition[$z][1], $match_x + $width, $match_y + 0.5*$width, 
        $insert_x - 0.5*$diamond_s, $insert_y + 0.5*$diamond_s, $z);
 # Match -> Match
  &draw_trans($transition[$z][0], $match_x + $width, $match_y + 0.5*$width,
        $match_x + $node_width, $match_y + 0.5*$width, $z);

 # Insert -> Match
  &draw_trans($transition[$z][3], 
        $insert_x + 0.5*$diamond_s, $insert_y + 0.5*$diamond_s,
        $match_x + $node_width, $match_y + 0.5*$width,
        $z);

 # Delete -> Delete
  &draw_trans($transition[$z][6], 
        $delete_x + $width , $delete_y + 0.5*$width,
        $delete_x + $node_width, $delete_y + 0.5*$width,
        $z);
 # Delete -> Match
  &draw_trans($transition[$z][5], 
        $delete_x + $width, $delete_y + 0.5*$width,
        $match_x + $node_width, $match_y,
        $z);

 # Begin -> Match
 if ($z != 1) {
   &draw_trans($transition[$z][7], 
        $match_x + 3*$max_line, $match_y + 2.5*$width,
        $match_x + 3*$max_line, $match_y + 1.5*$width,
        $z);
 }
 # Match -> End
 if ($z != $leng) {
   &draw_trans($transition[$z][8], 
        $match_x + 7*$max_line, $match_y + 1.5*$width,
        $match_x + 7*$max_line, $match_y + 2.5*$width,
        $z);
 }

 # Insert -> Insert
 if ($transition[$z][4] > $cutoff) {
   $mmodel_v->createLine(
        $insert_x - 0.5*$diamond_s, $insert_y + 1.7*$diamond_s,
        $insert_x - 0.7*$diamond_s, $insert_y + 2.1*$diamond_s,
        $insert_x - 1.2*$diamond_s, $insert_y + 2.4*$diamond_s,
        $insert_x - 1.5*$diamond_s, $insert_y + 1.8*$diamond_s,
        $insert_x - 0.7*$diamond_s, $insert_y + 1.3*$diamond_s,
        -smooth => 1,
        -splinesteps => 15,
        -fill => &set_color($transition[$z][4]),
        -tags => [$z, 'state_v', 'data'],
        -arrow => 'last',
        -width => 2);
 }
 $mmodel_v->update();	# Flush Buffer
} # End for loop
 \&control_ihist();
 \&control_mhist();

 $le = 2/($nodes + 4);
 $mmodel_v->xview('moveto', $le);

} # End build_trans

# Arrow drawing subroutine 
sub draw_trans {
  my $prob = shift;
  my $x1 = shift; my $y1 = shift;
  my $x2 = shift; my $y2 = shift;
  my $tag_value = shift;

  my $arrowcolor = 'black';

  if ($prob > $cutoff) {
    $arrowcolor = &set_color($prob);
    $mmodel_v->createLine($x1, $y1, $x2, $y2,
        -arrow => 'last',
        -fill => $arrowcolor,
        -tags => [$tag_value, 'mmodel_v', 'data'],
        -width => 2);
  }
  return 1;
}

# Sets the graident of grey for the transition arrows in the
# main model view
sub set_color {
  my $prob = shift;

  $colornum = int((1-$prob)*100);
  if ($colornum > 90) { return 'grey91'; }
  return ('grey' . $colornum);  
}

# Match Histgrams Subroutine -- draws histograms for main model view
sub mm_match_hist {

$mmodel_v->delete('mhist');

for ($j = 0, $z = $start_value, $t = 1; 
	$t < ($nodes + 1); 
	$j = $j + $node_width, $z++, $t++) {

  # Location in x plane
  $match_x = $j;
  $hist_x = $match_x + $width/3;
  # Location in the y plane
  $hist_y = 2.7*$interval;
  # Total height of the histogram
  $hist_h = int(0.85*$interval);

  for ($s = 0, $i = $hist_y - $hist_h;
        $s < $alpha; $s++, $i = $i + $hist_h/$alpha) {

     # Choose histogram colors based on having pos score
     if ($match_score[$z][$s] > 0) {
        $sigcolor = 'blue';
        $mmodel_v->createText($hist_x - 1, $i,
          -text => $E_alpha_char[$s],
          -font => $courier2,
          -anchor => 'ne',
          -tags => [$z, 'mmodel_v', 'mhist'],
          -fill => 'black');
     } else {
        $sigcolor = 'lightblue';
     }
     $x2 = $hist_x + $match[$z][$s] * $node_width/3;
     $mmodel_v->createRectangle($hist_x,$i,$x2,$i + $hist_h/$alpha,
        -width => 1,
        -fill => $sigcolor,
        -outline => $sigcolor,
        -tags => [$z, 'mmodel_v', 'mhist']);
  } # for each alpha in the node 
  $mmodel_v->update();	#Flush Buffer
} # for each node in the model
} # End mm_match_hist subroutine

# Insert Histogram Subroutine -- draws histograms for main model view
sub mm_insert_hist {
if ($nodes <= 9) {

$mmodel_v->delete('ihist');

for ($j = 0, $z = $start_value, $t = 1; 
	$t < ($nodes + 1); 
	$j = $j + $node_width, $z++, $t++) {

  # Location in x plane
  $insert_x = $j + $node_width/2;
  $hist_x = $insert_x;
  # Location in y plane
  $hist_y = 2.6*$interval;
  # Total histogram height
  $hist_h = int(0.65*$interval);

  if ($z < $leng) {	# Last node doesn't have insert
    for ($s = 0, $i = $hist_y - $hist_h;
	$s < $alpha; $s++, $i = $i + $hist_h/$alpha) {
     $x2 = $hist_x + $insert[$z][$s] * $node_width/3;
     $mmodel_v->createRectangle($hist_x,$i,$x2,$i + $hist_h/$alpha,
	-fill => $insert_color,
	-outline => $insert_color,
        -tags => [$z, 'mmodel_v', 'ihist'],
        -width => 1);
    } # for each alpha in the node
  } # if z < leng 
  $mmodel_v->update();  # Flush Buffer
} # for each node in the model
} # if $nodes < 9  (gets too cluttered at greater zoom)
} # end mm_insert_hist subroutine

sub see_hist {  
   my ($window, $x) = @_;
 
   $x_coord = $window->canvasx($x);
   $t = int($x_coord/$node_width) + 1;	# Index of choosen node 
   $x_coord = ($t - 1)*$node_width - 3;
   if (($t > 0) && ($t <= $leng)) {
      if ($hist_visible != 1) {
        &build_hist_v();
	$hist_visible = 1;
      }
      &draw_hist($start_value + ($t - 1), $x_coord);
   }
   $curr_select = $start_value + ($t - 1);
}


$end = 1;
