# plan7.pl
# Plan 7 Architecture

# Start State
$plan7_v->createOval(
        0.5*$interval - $p7width, 0.5*$interval - $p7width,
        0.5*$interval, 0.5*$interval,
        -fill => $plan7_color,
        -outline => $plan7_color);
$plan7_v->createText(
        0.5*$interval - 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        -anchor => 'center',
        -text => "S",
        -fill => 'black');

# N Insert State
$plan7_v->createPolygon(
        int(0.75*$interval), 0.5*$interval - $p7width,
        0.75*$interval - 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        0.75*$interval, 0.5*$interval,
        0.75*$interval + 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        -outline => $plan7_color,
        -fill => $plan7_color);
$plan7_v->createText(
        0.75*$interval, 0.5*$interval - 0.5*$p7width,
        -text => "N",
        -fill => 'black');

# Begin State
$plan7_v->createOval(
        $interval, 0.5*$interval - $p7width,
	$p7width + $interval, 0.5*$interval,
        -fill => $plan7_color,
        -outline => $plan7_color);

$plan7_v->createText(
        $interval + 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        -text => "B",
        -fill => 'black');

# Main Window Box
$p7scroll = $plan7_v->Canvas(
	-height => $p7width,
	-width => $interval + 2,
	-takefocus => 0,
	-background => $plan7_color);
$plan7_v->createWindow( 2*$interval, 0.5*$interval - 0.5*$p7width,
	-window => $p7scroll);

# End State
$plan7_v->createOval(
	3*$interval - $p7width, 0.5*$interval - $p7width,
        3*$interval, 0.5*$interval,
        -fill => $plan7_color,
        -outline => $plan7_color);
$plan7_v->createText(
        3*$interval - 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        -text => "E",
        -fill => 'black');

# C Insert State
$plan7_v->createPolygon(
        3.25*$interval, 0.5*$interval - $p7width,
        3.25*$interval - 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        3.25*$interval, 0.5*$interval,
	3.25*$interval + 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        -outline => $plan7_color,
        -fill => $plan7_color);
$plan7_v->createText( 3.25*$interval, 0.5*$interval - 0.5*$p7width,
        -text => "C",
        -fill => 'black');

# Terminate State
$plan7_v->createOval(
        3.5*$interval, 0.5*$interval - $p7width,
        $p7width + 3.5* $interval, 0.5*$interval,
        -fill => $plan7_color,
        -outline => $plan7_color);
$plan7_v->createText(
        3*$interval + 0.5*$interval + 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        -text => "T",
        -fill => 'black');

# Main Model Box
sub draw_plan7_v {

$plan7_v->delete("scrollline", "title", "p7sb", "p7arrow");
$p7scroll->delete("p7sb");

$p7s = $p7scroll->createRectangle(
        3, 4, 3 + $interval*$nodes/$leng, $p7width,
        -fill => 'white',
        -width => 2,
        -outline => 'black',
        -tags => 'p7sb');
if ($transition[2][7] > .00001) {
  $bm = 1;
  $plan7_v->createLine(
        $interval + 0.5*$p7width, 0.5*$interval -$p7width,
        $interval + 0.5*$p7width, 0.4*$interval - $p7width,
        1.5*$interval + .5*$interval*$num_interval/$leng, 
                0.4*$interval - $p7width,
        1.5*$interval + .5*$interval*$num_interval/$leng, 
                0.5*$interval - $p7width,
         -smooth => 0,
        -tags => 'scrollline',
        -joinstyle => 'bevel',
        -arrow => 'last',
        -fill => 'grey',
        -width => 1);
  $plan7_v->createLine(
        3*$interval - 0.5*$p7width, 0.5*$interval,
        3*$interval - 0.5*$p7width, 0.6*$interval,
        1.5*$interval + .5*$interval*$num_interval/$leng, 0.6*$interval,
        1.5*$interval + .5*$interval*$num_interval/$leng, 0.5*$interval,
        -smooth => 0,   
        -tags => 'scrollline',
        -joinstyle => 'bevel',
        -arrow => 'first',
        -fill => 'grey',
        -width => 1);
}

# Start -> N Transition
&p7_tran_line (1,	# Start to N state with prob 1
	0.5*$interval, 0.5*$interval - 0.5*$p7width,
        0.75*$interval - 0.5*$p7width, 0.5*$interval - 0.5*$p7width);

# N -> Begin Transition
&p7_tran_line ($xt[0],
        0.75*$interval + 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        $interval, 0.5*$interval - 0.5*$p7width);

# N -> N Transition
$p7_diag = sqrt(0.5*((0.5*$p7width)**2));
&p7_tran_loop ($xt[1],
	0.75*$interval + 0.5*$p7_diag, 0.5*$interval - $p7width + 0.4*$p7_diag,
	0.75*$interval + 0.5*$p7width, 0.5*$interval - 1.4*$p7width,
	0.75*$interval - 0.5*$p7width, 0.5*$interval - 1.4*$p7width,
	0.75*$interval - 0.5*$p7_diag, 0.5*$interval - $p7width + 0.5*$p7_diag,
	"NN");

# Begin-> Model Transition
$arrowcolor = &set_color($edge_t[0]);
$plan7_v->createLine(
	$interval + $p7width, 0.5*$interval - 0.5*$p7width,
	1.5*$interval, 0.5*$interval - 0.5*$p7width,
	-smooth => 0,
	-joinstyle => 'bevel',
	-arrow => 'last',
	-tags => ['p7arrow', 'p7sb'],
	-fill => $arrowcolor,
	-width => 1);

# Model -> End Transition
$plan7_v->createLine(
	2.5*$interval, 0.5*$interval - 0.5*$p7width,
	3*$interval - $p7width, 0.5*$interval - 0.5*$p7width,
	-smooth => 0,
	-joinstyle => 'bevel',
	-arrow => 'last',
	-tags => ['p7arrow', 'p7sb'],
	-fill => 'grey0',
	-width => 1);

# End -> C Transition
&p7_tran_line ($xt[2],
        3*$interval, 0.5*$interval - 0.5*$p7width,
        3.25*$interval - 0.5*$p7width, 0.5*$interval - 0.5*$p7width);

# C -> C Transition
&p7_tran_loop ($xt[5],
	3.25*$interval + 0.5*$p7_diag, $interval/2 - $p7width + 0.4*$p7_diag,
	3.25*$interval + 0.5*$p7width, 0.5*$interval - 1.4*$p7width,
	3.25*$interval - 0.5*$p7width, 0.5*$interval - 1.4*$p7width,
	3.25*$interval - 0.5*$p7_diag, 0.5*$interval - $p7width + 0.5*$p7_diag,
	"CC");

# C -> Terminate Transition
&p7_tran_line ($xt[4],
        3.25*$interval + 0.5*$p7width, 0.5*$interval - 0.5*$p7width,
        3.5*$interval, 0.5*$interval - 0.5*$p7width);

if ($xt[3] > .00001) {
  $ej = 1;
# J Insert State
  $plan7_v->createPolygon(
        2*$interval, 0.75 * $interval,
	2*$interval - 0.5*$p7width, 0.75*$interval + 0.5*$p7width,
        2*$interval, 0.75*$interval + $p7width,
        2*$interval + 0.5*$p7width, 0.75*$interval + 0.5*$p7width,
        -outline => $plan7_color,
	-tags => 'title',
        -fill => $plan7_color);
  $plan7_v->createText(
        2*$interval, 0.75*$interval + 0.5*$p7width,
        -text => "J",
	-tags => 'title',
        -fill => 'black');
# J-> J Transition
  &p7_tran_loop ($xt[7],
        2*$interval + 0.5*$p7_diag, 0.75*$interval + 0.4*$p7_diag,
        2*$interval + 0.5*$p7width, 0.75*$interval - 0.4*$p7width,
        2*$interval - 0.5*$p7width, 0.75*$interval - 0.4*$p7width,
        2*$interval - 0.5*$p7_diag, 0.75*$interval + 0.5*$p7_diag,
	"title");

# E -> J Transition
  $arrowcolor = &set_color($xt[3]);
  $plan7_v->createLine(
        3*$interval - 2, 0.5*$interval - 0.5*$p7width + 5,
        3.1*$interval, 0.75*$interval - 0.5*$p7width,
        2.8*$interval, 0.75*$interval + 0.4*$p7width,
        2*$interval + 0.5*$p7width, 0.75*$interval + 0.5*$p7width,
	-smooth => 1,
	-tags => ['p7arrow', 'p7sb'],
	-joinstyle => 'bevel',
	-arrow => 'last',
	-fill => $arrowcolor,
	-width => 1);

# J -> B Transition
  $arrowcolor = &set_color($xt[6]);
  $plan7_v->createLine(
        2*$interval - 0.5*$p7width, 0.75*$interval + 0.5*$p7width,
        1.1*$interval, 0.75*$interval + 0.4*$p7width,
        0.8*$interval, 0.75*$interval - 0.5*$p7width,
	$interval + 2, 0.5*$interval - 0.5*$p7width + 4,
	-smooth => 1,
	-tags => ['p7arrow', 'p7sb'],
	-joinstyle => 'bevel',
	-arrow => 'last',
	-fill => $arrowcolor,
	-width => 1);
}

# Model Name
$filler->createText(1.7*$interval,7, 
        -tag => 'n',
        -text => $model_name,
        -font => $courier,
        -fill => 'black');      

# Algorithm Type
if ($ej != 0) {		# LS or FS
  if ($bm != 0) {	# FS
    $alg = "Multihit Smith Waterman"
  } else {		# LS
    $alg = "Multihit Needleman Wunch"
  }
} else {		# SW or GLOBAL
  if ($bm != 0) {	# SW 
    $alg = "Smith Waterman"
  } else {		# GLOBAL
    $alg = "Needleman Wunch"
  }
}
$plan7_v->createText(
	4*$interval - 0.2*$p7width, $interval - 0.5*$p7width,
	-anchor =>'e',
	-tag => 'title',
	-text => $alg,
	-font => $courier,
	-fill => 'black');

$plan7_v->Tk::bind("<Button-1>", [\&see_p7_hist, Ev('x')]);

}

sub see_p7_hist {

  if ($hist_visible !=1 ) {
    &build_hist_v();
    $hist_visible = 1;
  } 

  $h_width = (2*$interval)/11;
  $in_p7 = 1;

  # Draw histogram containing p7 transitions
  $mprob_v->delete("histogram");
  $iprob_v->delete("histogram");
  $tprob_v->delete("histogram");
  $prob_title->delete("histogram");
  $mmodel_v->delete("histogram");
 
  if ($use_probs) { 
     $x1 = 0;
  } else {
     $x1 = 0.70*$interval;
  }

  # double index to allow for blank rows between groups that sum to 1
  for ($i = 0, $k = 0; $k < 11; $k++) {
    if ($k == 2) { $i = 2;
    } elsif ($k == 5) { $i = 4;
    } elsif ($k == 8) { $i = 6;
    } else { 
     if ($use_probs) { 
       $x2 = 1.4*$interval*$xt[$i];
     } else {
       if ($xt[$i] > 0) {
          $x2 = $x1 + 0.70*$interval*($xt_s[$i]/5000);
       } else {
          $x2 = $x1 - 0.70*$interval*($xt_s[$i]/(-5000));
       }
     }
    $iprob_v->createRectangle(
	$x1, $k*$h_width,
        $x2, $k*$h_width + $h_width,
        -fill => $plan7_color,
        -tags => 'histogram',
        -outline => 'black');
    $iprob_v->createText(
        2*$interval,$k*$h_width +0.5*$h_width,
        -anchor => 'se',
        -fill => 'black',
        -font => $courier2,
        -tags => 'histogram',
        -text => &print_p7_score($i));
    $i++;
    }
   }
}

sub print_p7_score {
  my $pos = shift;
  
  if ($pos == 0) {
    $label = "N->B";
  } elsif ($pos == 1) {
    $label = "N->N";
  } elsif ($pos == 2) {
    $label = "E->C";
  } elsif ($pos == 3) {
    $label = "E->J";
  } elsif ($pos == 4) {
    $label = "C->T";
  } elsif ($pos == 5) {
    $label = "C->C";
  } elsif ($pos == 6) {
    $label = "J->B";
  } else {
    $label = "J->J";
  }
  
  if ($use_probs) {
     return sprintf ("%s: %0.${digits}f", $label, $xt[$pos]);
  } else {
     return sprintf ("%s: %6d", $label, $xt_s[$pos]);
  }
}

# Subroutine for drawing arrows in p7 view.
sub p7_tran_line {
  my $prob = shift;
  my $x1 = shift; my $y1 = shift;
  my $x2 = shift; my $y2 = shift;
 
  $arrowcolor = &set_color($prob); 
  $plan7_v->createLine($x1, $y1, $x2, $y2,
	-arrow => 'last',
	-fill => $arrowcolor,
	-tags => ['p7arrow', 'p7sb'],
	-width => 1);
}

sub p7_tran_loop {
  my $prob = shift;
  my $x1 = shift; my $y1 = shift;
  my $x2 = shift; my $y2 = shift;
  my $x3 = shift; my $y3 = shift;
  my $x4 = shift; my $y4 = shift;
  my $tag = shift;
  
  $arrowcolor = &set_color($prob); 
  $plan7_v->createLine($x1, $y1, $x2, $y2, $x3, $y3, $x4, $y4,
	-smooth => 1,
	-joinstyle => 'bevel',
	-arrow => 'last',
	-fill => $arrowcolor,
	-tags => [$tag, 'p7sb'],
	-width => 1);
}

# Plan 7 selection should bring up its probability histogram
# in the histogram view window.

$end = 1;
